/******************************************************************************
*
*    ltoa (a functions that is not available on all systems)
*    Copyright (C) 1993 A. Bode, S. Lamberts, T. Ludwig, G. Stellner
*
*    This file is part of NXLIB (Paragon(TM) message passing on workstations)
*
*    NXLIB is free software; you can redistribute it and/or
*    modify it under the terms of the GNU Library General Public
*    License as published by the Free Software Foundation; either
*    version 2 of the License, or (at your option) any later version.
*
*    NXLIB is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*    Library General Public License for more details.
*
*    You should have received a copy of the GNU Library General Public
*    License along with this library; if not, write to the Free
*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    Contact to the authors:
*
*    electronic mail: nxlib@informatik.tu-muenchen.de
*
*    paper mail:      Prof. Dr. A. Bode
*                     Lehrstuhl f"ur Rechnertechnik und Rechnerorganisation
*                     Institut f"ur Informatik
*                     Technische Universit"at M"unchen
*                     80290 M"unchen
*                     Germany
*
*    Paragon(TM) is a trademark of Intel Corporation.
*
******************************************************************************/
/******************************************************************************

  ltoa.c,v
  1994/12/30 16:32:57
  1.5
  Exp
  lamberts
 
  Authors: Stefan Lamberts

  Description:

     This file contains ltoa(). A Function to convert longs into ascii.

  Available functions from this module:

     char *ltoa(l)
     long l;
     
******************************************************************************/
#ifndef lint
static char rcs_id[] = "ltoa.c,v 1.5 1994/12/30 16:32:57 lamberts Exp";
#endif


#include <stdio.h>
#include <stdlib.h>

#include "../include/nxmalloc.h"


/*****************************************************************************/
char *ltoa
#ifdef ANSI
(long l)
#else
(l)
long l;
#endif
/*****************************************************************************/
{
  int len;
  long tl;
  char *str;
  
  for (tl = l, len = 2; (tl /= 10) != 0; len++);

  if (l < 0)
    len++;

  if ((str = malloc((size_t)len)) == (char *)0)
    return ((char *)0);
  
  sprintf(str,"%ld",l);
  return (str);
}

  




